import math

class Point:
    def __init__(self, x, y):
        self.x = x
        self.y = y

def distance(p1, p2):
    return math.sqrt((p1.x - p2.x) ** 2 + (p1.y - p2.y) ** 2)

n = int(input())

points = []
for i in range(n):
    x, y = map(float, input().split())
    points.append(Point(x, y))

if n == 2:
    ans = distance(points[0], points[1])
    print(ans)
else:
    vec = []

    for i in range(3):
        for j in range(i + 1, 3):
            p1 = points[i]
            p2 = points[j]
            p3 = points[3 - i - j]

            side1 = distance(p1, p2)
            side2 = distance(p1, p3)
            side3 = distance(p2, p3)

            vec.append((side1, side2, side3))

    minim = 1e9

    for sides in vec:
        minim = min(minim, sides[0] + sides[1], sides[0] + sides[2], sides[1] + sides[2])
    print(minim)