#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long
#define double long double

struct pr{
    int f, s;
};

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    priority_queue<pair<int, int>> q;
    vector<int> power(n, -1);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        p--;
        power[p] = h;
        q.push({p, h});
    }
    while (!q.empty()) {
        int v = q.top().first;
        int h = q.top().second;
        q.pop();
        if (power[v] > h || !h) continue;
        for (auto u : g[v]) {
            if (power[u] < h - 1) {
                power[u] = h - 1;
                q.push({u, (h - 1)});
            }
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (power[i] != -1) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();;
    }
}
